"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var svg_builder_1 = require("./svg-builder");
var svg_node_1 = require("./svg-node");
var svg_region_1 = require("./svg-region");
var svg_path_1 = require("./svg-path");
var SvgDrawing = /** @class */ (function (_super) {
    __extends(SvgDrawing, _super);
    function SvgDrawing(size) {
        var _this = _super.call(this, new svg_node_1.SvgNode('svg', SvgDrawing.getSvgAttributes(size))) || this;
        _this.nextRegionId = 0;
        _this.nextPathId = 0;
        _this.defs = new svg_node_1.SvgNode('defs');
        _this.root.add(_this.defs);
        _this.styles = new svg_node_1.SvgNode('style', { type: 'text/css' });
        _this.defs.add(_this.styles);
        return _this;
    }
    SvgDrawing.getSvgAttributes = function (size) {
        var result = {
            'version': '1.1',
            'xmlns': 'http://www.w3.org/2000/svg',
            'xmlns:xlink': 'http://www.w3.org/1999/xlink'
        };
        if (size) {
            result['viewBox'] = "0 0 " + size.width + " " + size.height;
        }
        return result;
    };
    SvgDrawing.prototype.generateRegionId = function () {
        return "rg_" + this.nextRegionId++;
    };
    SvgDrawing.prototype.generatePathId = function () {
        return "path_" + this.nextPathId++;
    };
    SvgDrawing.prototype.createRegion = function () {
        var id = this.generateRegionId();
        var region = new svg_region_1.SvgRegion(this, id);
        this.defs.add(region.root);
        return region;
    };
    SvgDrawing.prototype.createPath = function () {
        var id = this.generatePathId();
        var path = new svg_path_1.SvgPath(id);
        this.defs.add(path.root);
        return path;
    };
    SvgDrawing.prototype.addPattern = function (svgPattern) {
        this.defs.add(svgPattern);
    };
    SvgDrawing.prototype.addStyle = function (svgStyle) {
        this.styles.add(svgStyle);
    };
    SvgDrawing.prototype.svg = function () {
        return this.root.toString();
    };
    return SvgDrawing;
}(svg_builder_1.AbstractSvgBuilder));
exports.SvgDrawing = SvgDrawing;
