"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SvgNode = /** @class */ (function () {
    function SvgNode(name, attributes) {
        this.name = name;
        this.children = [];
        this.attributes = attributes || {};
    }
    SvgNode.prototype.add = function (node) {
        this.children.push(node);
    };
    SvgNode.prototype.clear = function () {
        this.children = [];
    };
    SvgNode.prototype.toString = function () {
        var _this = this;
        var attrStr = Object.keys(this.attributes).reduce(function (acc, attr) { return acc + " " + attr + "=\"" + _this.attributes[attr] + "\""; }, '');
        var childrenStr = this.children.map(function (x) { return x.toString(); });
        return "<" + this.name + attrStr + ">" + childrenStr.join('') + "</" + this.name + ">";
    };
    return SvgNode;
}());
exports.SvgNode = SvgNode;
